<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

//The class responsiblle for creating a custom post type
class WPPTabsCustomPostType {

    function __construct() {
        //Add custom posts
        add_action('init', array(&$this, 'add_custom_post_type'));
        // add metabox
        add_action('add_meta_boxes', array(&$this, 'register_meta_box'));
        add_action('save_post', array(&$this, 'wpptabs_update_meta_fields'));
        add_action('new_to_publish', array(&$this, 'wpptabs_update_meta_fields'));
        add_action('draft_to_publish', array(&$this, 'wpptabs_update_meta_fields'));
        add_action('pending_to_publish', array(&$this, 'wpptabs_update_meta_fields'));
        add_action('future_to_publish', array(&$this, 'wpptabs_update_meta_fields'));
        add_action('admin_enqueue_scripts', array(&$this, 'wpptabs_table_modifier'));
        add_action('admin_print_styles', array(&$this, 'wpptabs_enqueue_styles'));
        //add capabilities to admin
        add_action('admin_init', array(&$this, 'wpptabs_add_admin_capabilities'));
  

        add_action('admin_enqueue_scripts', array(&$this, 'save_jeditable_ajax_send'));
        add_action('wp_ajax_save_jeditable', array(&$this, 'save_jeditable_ajax_return'));
        add_action('admin_enqueue_scripts', array(&$this, 'rowcol_counter_js_send'));
        add_action('wp_ajax_modify_counter', array(&$this, 'rowcol_counter_ajax_update'));
	   add_action('wp_ajax_sort_map', array(&$this, 'rowcol_sort_ajax_update'));
	   add_action('wp_ajax_get_billings', array(&$this, 'get_billings'));
	   add_action('wp_ajax_nopriv_get_billings', array(&$this, 'get_billings'));
    }

    // The post type constructor
    public function add_custom_post_type() {

        $swpd_post_type_args = array(
            'public' => true,
            'query_var' => 'wpptabs',
            'rewrite' => array(
                'slug' => 'cwp-wppt-pricing-table',
                'with_front' => false,
                'capability_type' => 'wpptabs',
                'map_meta_cap' => true
            ),
            'capabilities' => array(
                'edit_post' => 'edit_wpptabs',
                'edit_others_posts' => 'edit_others_wpptabs',
                'publish_posts' => 'publish_wpptabs',
                'read_post' => 'read_wpptabs',
                'read_private_posts' => 'read_private_wpptabs',
                'delete_post' => 'delete_wpptabs'
            ),
            'menu_icon' => WPPTABS_URLPATH . '/images/pt-icon.png',
            'supports' => array(
                'title'
            ),
            'labels' => array(
                'name' => 'Pricing Tables',
                'singular_name' => 'Pricing Table',
                'add_new' => 'Add Pricing Table',
                'add_new_item' => 'Add Pricing Table',
                'edit_item' => 'Edit Pricing Table',
                'new_item' => 'New Pricing Table',
                'view_item' => 'View Pricing Table',
                'search_items' => 'Search Pricing Tables',
                'not_found' => 'No Pricing Tables Found',
                'not_found_in_trash' => 'No Pricing Tables Found In Trash'
            )
        );
        register_post_type('wpptabs', $swpd_post_type_args);
    }

    function wpptabs_add_admin_capabilities() {
        //add capabilities for admin
        $role_object = get_role('administrator');
        $role_object->add_cap('read_wpptabs');
        $role_object->add_cap('edit_wpptabs');
        $role_object->add_cap('delete_wpptabs');
        $role_object->add_cap('publish_wpptabs');
        $role_object->add_cap('edit_others_wpptabs');
    }

    function register_meta_box() {
        // table styling metabox
        add_meta_box('wpptabs_table_styling', __('Pricing table styling', 'wpptabs'), array(&$this, 'render_table_styling'), 'wpptabs', 'normal', 'high');
        //config table metabox
        add_meta_box('wpptabs_config_table', __('Modify pricing table', 'wpptabs'), array(&$this, 'render_config_table'), 'wpptabs', 'normal', 'high');
		 add_meta_box('wpptabs_config_table_price', __('Modify billing periods', 'wpptabs'), array(&$this, 'render_config_table_price'), 'wpptabs', 'normal', 'high');
    }

    function render_config_table() {
	 global $typenow;
        if ($typenow == "wpptabs") {
        include_once ( WPPTABS_DIRNAME . "/views/config_table.php" );
		}
    }
   function render_config_table_price() {
    global $typenow;
        if ($typenow == "wpptabs") {
        include_once ( WPPTABS_DIRNAME . "/views/config_table_price.php" );
		}
    }
    function render_table_styling() {
	 global $typenow;
        if ($typenow == "wpptabs") {
        include_once ( WPPTABS_DIRNAME . "/views/table_styling.php" );
		}
    }

    function wpptabs_table_modifier() {
        global $typenow;
        if ($typenow == "wpptabs") {
            //add javascript to PA
            wp_register_script('wpptabs-jeditable-lib-sortable', WPPTABS_URLPATH . '/js/jquery.ui.sorttable.js', 'null', 'null', 'true');
			wp_register_script('wpptabs-jeditable-lib', WPPTABS_URLPATH . '/lib/includes/jeditable/jeditable.min.js', 'null', 'null', 'true');
			wp_register_script('wpptabs-switch', WPPTABS_URLPATH . '/js/switch.js', 'null', 'null', 'true');
            wp_register_script('wpptabs-jeditable-script', WPPTABS_URLPATH . '/js/wpptabs_jeditable.js', 'null', 'null', 'true');
            wp_register_script('wpptabs-table-modifier', WPPTABS_URLPATH . '/js/table_modifier.js', 'null', 'null', 'true');
           /* wp_register_script('wpptabs-dragtable', WPPTABS_URLPATH . '/lib/includes/dragtable/dragtable.js', 'null', 'null', 'true'); */
            wp_register_script('wpptabs-design_select_sequencer', WPPTABS_URLPATH . '/js/design_select_sequencer.js', 'null', 'null', 'true');
            wp_register_script('wpptabs-design_select_sequencer', WPPTABS_URLPATH . '/js/checbox.js', 'null', 'null', 'true');
			wp_enqueue_script('wpptabs-jeditable-lib');
			wp_enqueue_script('wpptabs-switch');
            wp_enqueue_script('wpptabs-jeditable-script');
            wp_enqueue_script('wpptabs-table-modifier');
           /* wp_enqueue_script('wpptabs-dragtable');*/
            wp_enqueue_script('wpptabs-jeditable-lib-sortable');
            wp_enqueue_script('wpptabs-design_select_sequencer');
        }
    }

    function wpptabs_enqueue_styles() {
        global $typenow;
        if ($typenow == "wpptabs") {
            wp_register_style('wpptabs-config-table', WPPTABS_URLPATH . '/css/admin.css');
			 wp_register_style('wpptabs-config-table-bootstrap', WPPTABS_URLPATH . '/css/bootstrap.css');
           
            
            wp_enqueue_style('wpptabs-config-table');
        }
    }

    function wpptabs_update_meta_fields() {
        global $post;
        //update option of table
        if (isset($_POST['post_type']) && ($_POST['post_type'] == "wpptabs")) {
		$column_counter = get_post_meta(get_the_ID(), 'column_counter', true);
		$table_edit = get_post_meta('wpptabs_table-edit' . get_the_ID(),true);
		$row_index_price_map = unserialize(get_post_meta(get_the_ID(), 'row_index_price_map', true)) ;
 if($_POST['wpptabs_column_width']){  update_post_meta(get_the_ID(), 'wpptabs_column_width', $_POST['wpptabs_column_width']);
             }
	
            if ($_POST['wpptabs_selected_theme-' . get_the_ID()] !== '-Select Design-') {

                update_post_meta(get_the_ID(), 'wpptabs_selected_theme-' . get_the_ID(), $_POST['wpptabs_selected_theme-' . get_the_ID()]);
            } else {
                update_post_meta(get_the_ID(), 'wpptabs_selected_theme-' . get_the_ID(), '');
            }

            if ($_POST['wpptabs_selected_color-' . get_the_ID()] !== '-Select Color-') {
                update_post_meta(get_the_ID(), 'wpptabs_selected_color-' . get_the_ID(), $_POST['wpptabs_selected_color-' . get_the_ID()]);
            } else {
                update_post_meta(get_the_ID(), 'wpptabs_selected_color-' . get_the_ID(), '');
            }

            update_post_meta(get_the_ID(), 'wpptabs_hoverable-' . get_the_ID(), $_POST['wpptabs_hoverable-' . get_the_ID()]);

            for ($i = 1; $i <= $column_counter; $i++) {//update ribbon and tooltip settings and value
			 
			    if (isset($_POST['wpptabs_features' .$i.'-' . get_the_ID()])) {
               update_post_meta(get_the_ID(), 'wpptabs_features'.$i.'-' . get_the_ID(), $_POST['wpptabs_features' .$i.'-' . get_the_ID()]);
			   } else {
                }
			   
 
		   if (isset($_POST['wpptabs_tp' . $i . '-' . get_the_ID() . '_selected_position']) and ($_POST['wpptabs_tp' . $i . '-' . get_the_ID() . '_selected_position'] !== '-Select Tooltip Position-')) {
                    update_post_meta(get_the_ID(), 'wpptabs_tp' . $i . '-' . get_the_ID() . '_selected_position', $_POST['wpptabs_tp' . $i . '-' . get_the_ID() . '_selected_position']);
                } else {
                    update_post_meta(get_the_ID(), 'wpptabs_tp' . $i . '-' . get_the_ID() . '_selected_position', '');
                }
			   
                if ($_POST['wpptabs_tp' . $i . '-' . get_the_ID() . '_selected_color'] !== '-Select Tooltip Color-') {
				update_post_meta(get_the_ID(), 'wpptabs_is_tooltip-' . get_the_ID(),'1');
                    update_post_meta(get_the_ID(), 'wpptabs_tp' . $i . '-' . get_the_ID() . '_selected_color', $_POST['wpptabs_tp' . $i . '-' . get_the_ID() . '_selected_color']);
                } else {
                    update_post_meta(get_the_ID(), 'wpptabs_tp' . $i . '-' . get_the_ID() . '_selected_color', '');
                }

                if (isset($_POST['wpptabs_selected_ribbon' . $i . '-' . get_the_ID() . '_theme']) and ($_POST['wpptabs_selected_ribbon' . $i . '-' . get_the_ID() . '_theme'] !== '-Select Ribbon Color-')) {
				update_post_meta(get_the_ID(), 'wpptabs_is_ribbon-' . get_the_ID(),'1');
		
                    update_post_meta(get_the_ID(), 'wpptabs_selected_ribbon' . $i . '-' . get_the_ID() . '_theme', $_POST['wpptabs_selected_ribbon' . $i . '-' . get_the_ID() . '_theme']);
                } else {
                    update_post_meta(get_the_ID(), 'wpptabs_selected_ribbon' . $i . '-' . get_the_ID() . '_theme', '');
              
			  }

                if (isset($_POST['wpptabs_selected_ribbon' . $i . '-' . get_the_ID() . '_size']) and ($_POST['wpptabs_selected_ribbon' . $i . '-' . get_the_ID() . '_size'] !== '-Select Ribbon Size-')) {
                    update_post_meta(get_the_ID(), 'wpptabs_selected_ribbon' . $i . '-' . get_the_ID() . '_size', $_POST['wpptabs_selected_ribbon' . $i . '-' . get_the_ID() . '_size']);
                } else {
                    update_post_meta(get_the_ID(), 'wpptabs_selected_ribbon' . $i . '-' . get_the_ID() . '_size', '');
                }if (isset($_POST['wpptabs_ribbon' . $i . '-' . get_the_ID() . '_value'])) {
                    update_post_meta(get_the_ID(), 'wpptabs_ribbon' . $i . '-' . get_the_ID() . '_value', $_POST['wpptabs_ribbon' . $i . '-' . get_the_ID() . '_value']);
                } else {
                    update_post_meta(get_the_ID(), 'wpptabs_ribbon' . $i . '-' . get_the_ID() . '_value', '');
                }  
            
			                       foreach ($row_index_price_map as $ii) { 
  if($_POST['wpptabs_after_price'.$ii.'-'  . get_the_ID()]){  
        								  
								  update_post_meta(get_the_ID(), 'wpptabs_after_price'.$ii.'-'  . get_the_ID(), $_POST['wpptabs_after_price'.$ii.'-' . get_the_ID()]);
		     }	  if($_POST['wpptabs_button' .$ii.'-' . $i . '-' . get_the_ID() . '_value']){  update_post_meta(get_the_ID(), 'wpptabs_button' .$ii.'-' . $i . '-' . get_the_ID() . '_value', $_POST['wpptabs_button' .$ii.'-' . $i . '-' . get_the_ID() . '_value']);
             } else{
			 update_post_meta(get_the_ID(), 'wpptabs_button' .$ii.'-' . $i . '-' . get_the_ID() . '_value', '');
			 
			 } 
if($_POST['wpptabs_button'.$ii . '-' . $i . '-' . get_the_ID() . '_class']){  update_post_meta(get_the_ID(), 'wpptabs_button'.$ii . '-' . $i . '-' . get_the_ID() . '_class', $_POST['wpptabs_button'.$ii . '-' . $i . '-' . get_the_ID() . '_class']);
             } else{
			 update_post_meta(get_the_ID(), 'wpptabs_button'.$ii . '-' . $i . '-' . get_the_ID() . '_class', '');
			 
			 }			 if($_POST['wpptabs_price' .$ii.'-' . $i . '-' . get_the_ID() . '_value']){   update_post_meta(get_the_ID(), 'wpptabs_price'.$ii.'-' .  $i . '-' . get_the_ID() . '_value', $_POST['wpptabs_price'  .$ii.'-' . $i . '-' . get_the_ID() . '_value']);
               }else{
			 update_post_meta(get_the_ID(), 'wpptabs_price' .$ii.'-' . $i . '-' . get_the_ID() . '_value', '');
			 
			 }
			   if($_POST['wpptabs_button'.$ii.'-'  . $i . '-' . get_the_ID() . '_url']){ update_post_meta(get_the_ID(), 'wpptabs_button' .$ii.'-' . $i . '-' . get_the_ID() . '_url', $_POST['wpptabs_button'  .$ii.'-' . $i . '-' . get_the_ID() . '_url']);
           }  else{
			 update_post_meta(get_the_ID(), 'wpptabs_button'.$ii.'-'  . $i . '-' . get_the_ID() . '_url', '');
			 
			 }           
		   	  if($_POST['wpptabs_billing'.$ii. '-' . $i . '-' . get_the_ID() . '_name']){  update_post_meta(get_the_ID(), 'wpptabs_billing'.$ii. '-' . $i . '-' . get_the_ID() . '_name', $_POST['wpptabs_billing'.$ii. '-' . $i . '-' . get_the_ID() . '_name']);
             } 
			  if($_POST['wpptabs_billing'.$ii. '-' . $i . '-' . get_the_ID() . '_subject']){  update_post_meta(get_the_ID(), 'wpptabs_billing'.$ii. '-' . $i . '-' . get_the_ID() . '_subject', $_POST['wpptabs_billing'.$ii. '-' . $i . '-' . get_the_ID() . '_subject']);
             } 
			  if($_POST['wpptabs_action' .$ii . '-' . $i . '-' . get_the_ID() . '_text_higher']){  update_post_meta(get_the_ID(), 'wpptabs_action' .$ii . '-' . $i . '-' . get_the_ID() . '_text_higher', $_POST['wpptabs_action' .$ii . '-' . $i . '-' . get_the_ID() . '_text_higher']);
             }
			  if($_POST['wpptabs_action'. $ii . '-' .$i . '-' . get_the_ID() . '_text_lower']){  update_post_meta(get_the_ID(), 'wpptabs_action' .$ii . '-'. $i . '-' . get_the_ID() . '_text_lower', $_POST['wpptabs_action' .$ii . '-'. $i . '-' . get_the_ID() . '_text_lower']);
             }
			   if($_POST['wpptabs_currency'.$ii .'-' . $i .'-' . get_the_ID() . '_value']){  update_post_meta(get_the_ID(), 'wpptabs_currency'.$ii .'-' . $i . '-'  . get_the_ID() . '_value', $_POST['wpptabs_currency'.$ii .'-' . $i . '-'. get_the_ID() . '_value']);
             }
			  if($_POST['wpptabs_subtitle'.$ii .'-' . $i .'-' . get_the_ID() . '_value']){  update_post_meta(get_the_ID(), 'wpptabs_subtitle'.$ii .'-' . $i . '-'  . get_the_ID() . '_value', $_POST['wpptabs_subtitle'.$ii .'-' . $i . '-'. get_the_ID() . '_value']);
             }
			
			 if($_POST['wpptabs_time'.$ii . '-' . get_the_ID() . '_selected'] and $_POST['wpptabs_time'.$ii . '-' . get_the_ID() . '_selected']  !== '-Select Time option-'){  update_post_meta(get_the_ID(), 'wpptabs_time'.$ii . '-' . get_the_ID() . '_selected', $_POST['wpptabs_time'.$ii . '-' . get_the_ID() . '_selected']);
             }
			  if($_POST['wpptabs_time'.$ii . '-' . get_the_ID() . '_value']){  update_post_meta(get_the_ID(), 'wpptabs_time'.$ii . '-' . get_the_ID() . '_value', $_POST['wpptabs_time'.$ii . '-' . get_the_ID() . '_value']);
             }
			  

		   }
		   
		   
		   
		   
		   
		   } update_post_meta('wpptabs_table-edit' . get_the_ID(),2,true );  
			}
			 if($_POST['wpptabs_default_billing']){  update_post_meta(get_the_ID(), 'wpptabs_default_billing', $_POST['wpptabs_default_billing']);
             }
			 
       
    }
	

    function save_jeditable_ajax_send($page) {//ajax edit a table
        if (!in_array($page, array('post.php', 'post-new.php'))) {
            return;
			}
        wp_enqueue_script('extend_jeditable', plugins_url('actions.js', __FILE__), array( 'jquery'), '1.0.0');
        wp_localize_script('extend_jeditable', 'jeditable', array('id' => get_the_ID(), 'verify' => wp_create_nonce('extend_jeditable')));
    }

    function save_jeditable_ajax_return() {//ajax return a value
        if (!isset($_POST['value'], $_POST['id'], $_POST['action'], $_POST['ex_id'], $_POST['verify']) || $_POST['action'] != 'save_jeditable' || !wp_verify_nonce($_POST['verify'], 'extend_jeditable')) {
            die('Error: Variables are not correct');
        }

        $id = absint($_POST['ex_id']);
        $key = (string) $_POST['id'];
        $value = (string) $_POST['value'];

        if (!current_user_can('edit_post', $id) && !current_user_can('edit_page', $id)) {
            die('Error:: You do not have permition to edit this data');
        } elseif ($key == '') {
            die('Error: `ID` variable  is missing');
        }

        update_post_meta($id, 'wpptabs_' . $key, $value);

        echo $value;
        die;
    }

    function rowcol_counter_js_send() {//add a row
        global $typenow;
        if ($typenow != "wpptabs") {
            return;
        }
        //update_post_meta(get_the_ID(), 'row_counter', 3);
        wp_localize_script('wpptabs-table-modifier', 'rowcol_counter', array('row' => get_post_meta(get_the_ID(), 'row_counter', true),'row_price' => get_post_meta(get_the_ID(), 'row_price_counter', true), 'column' => get_post_meta(get_the_ID(), 'column_counter', true), 'post_id' => get_the_ID(), 'ajaxurl' => admin_url('admin-ajax.php'), 'verify' => wp_create_nonce('wpptabs-table-modifier')));
    
   
	}

    // updates counter of config table rows/columns on add/delete
    function rowcol_counter_ajax_update() {//add a column
        if (!isset($_POST['action'], $_POST['edited_post_id'], $_POST['rowcol'], $_POST['counter'], $_POST['verify']) || $_POST['action'] != 'modify_counter') {
            die('Error: Variables are not correct');
        }

        // chek if user can edit table and if counter was passed
        if (!current_user_can('edit_wpptabs', $_POST['edited_post_id'])) {
             die('Error:: You do not have permition to edit this data');
        } elseif ($_POST['counter'] == '') {
            die('Error: `row_counter` variable is missing');
        }

        $rowcol = $_POST['rowcol'];
        //when deleteing row/column
        if (isset($_POST['deleted_first_cell_id'])) {
            //get id of first deleted cell
            $deleted_first_cell_id = $_POST['deleted_first_cell_id'];
            //decide if row or column and extrat the proper index from id
            if ($_POST['rowcol'] == 'row') {
                $index2delete = $deleted_first_cell_id;
            }if ($_POST['rowcol'] == 'column') {
                $index2delete = $deleted_first_cell_id;
				update_post_meta($_POST['edited_post_id'], $rowcol .'_counter', $_POST['counter']);
				 
            }
            //delete row/column index from index map
            $rowcol_index_map = array();
            $temp_rowcol_index_map = array();
            $rowcol_index_map = unserialize(get_post_meta($_POST['edited_post_id'], $rowcol . '_index_map', true));
	
            foreach ($rowcol_index_map as $rowcol_index) {
                if ($rowcol_index != $index2delete) {
                    $temp_rowcol_index_map[] = $rowcol_index;
                }
            }
            //update index map
			if($rowcol!="row_price"){
            update_post_meta($_POST['edited_post_id'], $rowcol . '_index_map', serialize($temp_rowcol_index_map));
			}
			else{
			 update_post_meta($_POST['edited_post_id'], 'row_index_price_map', serialize($temp_rowcol_index_map));
			
			}
        } else { //when adding row/column
            //save incremented row/column counter
            update_post_meta($_POST['edited_post_id'], $rowcol . '_counter', $_POST['counter']);
            //add row/column index to the map
            $rowcol_index_map = array();
			if($rowcol!=="row_price" and $rowcol!=="sort"){
            $rowcol_index_map = unserialize(get_post_meta($_POST['edited_post_id'], $rowcol . '_index_map', true));
			
            }
			else{
			$rowcol_index_map = unserialize(get_post_meta($_POST['edited_post_id'],'row_index_price_map', true));
            
			}
            $rowcol_index_map[] = $_POST['counter'];
            //update index map
				if($rowcol!="row_price" and $rowcol!=="sort"){
            update_post_meta($_POST['edited_post_id'], $rowcol . '_index_map', serialize($rowcol_index_map));
			}
			else{
			update_post_meta($_POST['edited_post_id'], 'row_index_price_map', serialize($rowcol_index_map));
			
			
			}
           echo "added";
        }
        die;
    }
	function rowcol_sort_ajax_update() {//add a column
    ob_clean();
    
	 if (!current_user_can('edit_wpptabs', $_POST['edited_post_id'])) {
             die('Error:: You do not have permition to edit this data');
        } 
	update_post_meta($_POST['edited_post_id'], 'row_sort_map', serialize($_POST['row_sort_map']));
		
        die();	
	}
function get_billings(){
   ob_clean();
  $table_post_id = $_POST['counter'];
        $id = $_POST['counter'];
        $saved_theme = get_post_meta($table_post_id, 'wpptabs_selected_theme-'.$table_post_id, true);
        $billing_id = $_POST['billing_id'];
        $adres = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'].'?'.$_SERVER['QUERY_STRING'];
        $default = get_post_meta($table_post_id, 'wpptabs_default_billing', true);
        //get default billing period
        
        if ($default == ""    or $default == 0 or $default == 1)
        {
            $default = 2;
        }

        
        if ($billing_id == "0"    or $billing_id == "1"    or $billing_id == "")
        {
            $default = 2;
            $billing_id = 2;
        }
        else
        {
            $default = $billing_id;
        }

        $saved_color = get_post_meta($table_post_id, 'wpptabs_selected_color-'.$table_post_id, true);
        $column_index_map = unserialize(get_post_meta($table_post_id, 'column_index_map', TRUE));
        //get the max column id
        $row_index_map = unserialize(get_post_meta($table_post_id, 'row_index_map', TRUE));
        //get the max row id
        $row_index_price_map = unserialize(get_post_meta($table_post_id, 'row_index_price_map', true));
        //get the max row id
        
        if ($column_index_map == '' || $row_index_map == '')
        {
            echo _e("No data for pricing table found. Please check if you have entered correct table id.");
        }
        else
        if ($saved_theme != ''    and $saved_color != '')
        {
            //check settings of table
            wpptabs_pricing_tables_styles($table_post_id,$row_index_map,$column_index_map);
            include(WPPTABS_DIRNAME.'/views/'.$saved_theme.'-ajax.php');
        }
        else
        if ($saved_color == ''    and $saved_theme != '')
        {
            echo _e("There are not enough options set to display the pricing table.");
        }
        else
        {
            echo _e("There are not enough options set to display the pricing table.");
        }
  die();
}
}

// end of class
?>